package com.ym.mec.biz.service.impl;

import com.ym.mec.auth.api.client.SysUserFeignService;
import com.ym.mec.auth.api.entity.SysUser;
import com.ym.mec.biz.dal.dao.ClassGroupDao;
import com.ym.mec.biz.dal.dao.DemoGroupClassGroupMapperDao;
import com.ym.mec.biz.dal.dao.DemoGroupCoursesPlanDao;
import com.ym.mec.biz.dal.dto.DemoGroupApplyDto;
import com.ym.mec.biz.dal.dto.VipGroupApplyBaseInfoDto;
import com.ym.mec.biz.dal.entity.ClassGroup;
import com.ym.mec.biz.dal.entity.DemoGroupClassGroupMapper;
import com.ym.mec.biz.dal.enums.ClassGroupTypeEnum;
import com.ym.mec.biz.dal.enums.YesOrNoEnum;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ym.mec.biz.dal.dao.DemoGroupDao;
import com.ym.mec.biz.dal.entity.DemoGroup;
import com.ym.mec.biz.service.DemoGroupService;
import com.ym.mec.common.dal.BaseDAO;
import com.ym.mec.common.service.impl.BaseServiceImpl;

@Service
public class DemoGroupServiceImpl extends BaseServiceImpl<Long, DemoGroup>  implements DemoGroupService {
	
	@Autowired
	private DemoGroupDao demoGroupDao;
	@Autowired
	private ClassGroupDao classGroupDao;
	@Autowired
	private DemoGroupClassGroupMapperDao demoGroupClassGroupMapperDao;
	@Autowired
	private DemoGroupCoursesPlanDao demoGroupCoursesPlanDao;

	@Autowired
	private SysUserFeignService sysUserFeignService;

	@Override
	public BaseDAO<Long, DemoGroup> getDAO() {
		return demoGroupDao;
	}

	@Override
	public void demoGroupApply(DemoGroupApplyDto demoGroupApplyDto) {
		SysUser user = sysUserFeignService.queryUserInfo();
		demoGroupApplyDto.setUserId(user.getId());
		demoGroupDao.insert(demoGroupApplyDto);
		ClassGroup classGroup=new ClassGroup();
		classGroup.setName(demoGroupApplyDto.getName());
		classGroup.setType(ClassGroupTypeEnum.DEMO);
		classGroup.setDelFlag(YesOrNoEnum.NO);
		classGroupDao.insert(classGroup);
		DemoGroupClassGroupMapper demoGroupClassGroupMapper=new DemoGroupClassGroupMapper();
		demoGroupClassGroupMapper.setDemoGroupId(demoGroupApplyDto.getId());
		demoGroupClassGroupMapper.setClassGroupId(classGroup.getId());
		demoGroupClassGroupMapperDao.insert(demoGroupClassGroupMapper);
		demoGroupCoursesPlanDao.batchInsertByDates(demoGroupApplyDto.getCourseDates(),demoGroupApplyDto.getId());
	}

	/**
	 * @Author: Joburgess
	 * @Date: 2019/9/25
	 * 创建上课计划及跟新所属分部列表
	 */
	public void createCourseScheduleAndUpdateOrganId(Long demoGroupId){
		DemoGroup demoGroup=demoGroupDao.get(demoGroupId);

	}
}